'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _client = require('@feathersjs/client');

var _client2 = _interopRequireDefault(_client);

var _socketioClient = require('@feathersjs/socketio-client');

var _socketioClient2 = _interopRequireDefault(_socketioClient);

var _authenticationClient = require('@feathersjs/authentication-client');

var _authenticationClient2 = _interopRequireDefault(_authenticationClient);

var _socket = require('socket.io-client');

var _socket2 = _interopRequireDefault(_socket);

var _feathersReactive = require('feathers-reactive');

var _feathersReactive2 = _interopRequireDefault(_feathersReactive);

var _types = require('./types');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FeathersProvider = function (_PureComponent) {
  _inherits(FeathersProvider, _PureComponent);

  function FeathersProvider(props, context) {
    _classCallCheck(this, FeathersProvider);

    var _this = _possibleConstructorReturn(this, (FeathersProvider.__proto__ || Object.getPrototypeOf(FeathersProvider)).call(this, props, context));

    _this._addTimeout = function (ms) {
      _this._timeout = setTimeout(function () {
        _this._initialized = true;
        _this._clearTimeout();
        _this.forceUpdate();
      }, ms);
    };

    _this._clearTimeout = function () {
      if (_this._timeout) {
        clearTimeout(_this._timeout);
        _this._timeout = null;
      }
    };

    var socket = (0, _socket2.default)(props.wsEndpoint, _extends({
      transports: ['websocket'],
      forceNew: true
    }, props.socketioOptions));
    _this._initialized = false;
    _this._timeoutMs = socket.timeout;
    _this._timeout = null;
    _this.app = (0, _client2.default)().configure((0, _socketioClient2.default)(socket, props.feathersSocketioOptions)).configure((0, _feathersReactive2.default)({ idField: props.idField })).configure((0, _authenticationClient2.default)(props.feathersAuthOptions));
    return _this;
  }

  _createClass(FeathersProvider, [{
    key: 'getChildContext',
    value: function getChildContext() {
      return { feathers: this.app };
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      var _props = this.props,
          feathersSocketioOptions = _props.feathersSocketioOptions,
          connectionCallbacks = _props.connectionCallbacks;

      if (this._timeoutMs > 0) {
        this._addTimeout(this._timeoutMs);
      }
      // set up callbacks

      var _loop = function _loop(key) {
        if (connectionCallbacks.hasOwnProperty(key) && key !== 'connect') {
          _this2.app.io.on(key, function () {
            if (typeof connectionCallbacks[key] === 'function') {
              return connectionCallbacks[key]();
            }
            return null;
          });
        }
      };

      for (var key in connectionCallbacks) {
        _loop(key);
      }
      // must have a connected prop
      this.app.io.on('connect', function () {
        _this2._initialized = true;
        _this2._clearTimeout();
        _this2.forceUpdate();
        if (typeof connectionCallbacks.connect === 'function') {
          return connectionCallbacks.connect();
        }
      });
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this._clearTimeout();
      if (this.connectionTimeout) {
        clearTimeout(this.connectionTimeout);
        this.connectionTimeout = null;
      }
      this.app.io.removeAllListeners();
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          children = _props2.children,
          loader = _props2.loader;


      if (!this._initialized) {
        return loader;
      }

      return _react.Children.only(children);
    }
  }]);

  return FeathersProvider;
}(_react.PureComponent);

FeathersProvider.propTypes = _types.feathersWrapperPropTypes;
FeathersProvider.defaultProps = _types.feathersWrapperDefaultProps;
FeathersProvider.childContextTypes = {
  feathers: _propTypes2.default.object
};
exports.default = FeathersProvider;